@import "../../assets/utils";

.button {
  display: flex;
  cursor: pointer;
  position: relative;
}

.container {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-grow: 1;
}

.before {

  + .content {
    margin-left: 10px;
  }
}

.content {
  + .after {
    margin-left: 10px;
  }
}

.after {

}

@each $name, $height, $padding, $fontSize in (
                (xs, 40px, 9px 12px, 14px),
                (sm, 48px, 16px 17px, 16px),
                (md, 52px, 18px 20px, 20px),
                (lg, 54px, 20px 22px, 24px),
                (xl, 58px, 22px 24px, 26px),
                (xlg, 64px, 24px 26px, 30px),
) {
  .#{$name}Size {
    .container {
      padding: $padding;
    }

    .content {
      font-size: $fontSize;
    }

    &.isSquare {
      height: $height;
      width: $height;
      .container {
        padding: 0;
      }
    }
  }
}

.isDisabled {
  opacity: .7;
  pointer-events: mouseover;
  cursor: not-allowed;
}

.isBlock {
  width: 100%;
}

.pureState {

}

.primaryState {
  background: $color-primary;
  border-radius: 4px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.08);
  color: $color-secondary;
  font-weight: 600;
  line-height: 20px;
  font-size: 14px;

  .loadingProgress {
    background: transparentize(white, .7);
  }
}

.secondaryState {
  background: $color-secondary;
  border-radius: 4px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.08);
  color: $color-primary;
  font-weight: 600;
  line-height: 20px;
  font-size: 14px;

  .loadingProgress {
    background: transparentize($color-primary-darker, .8);
  }
}

.tertiaryState {
  background: $color-secondary;
  border-radius: 4px;
  box-shadow: inset 0 0 0 1px $color-primary;
  color: $color-primary;
  font-weight: 600;
  line-height: 20px;
  font-size: 14px;

  .loadingProgress {
    background: transparentize($color-primary-darker, .8);
  }
}

.quaternaryState {
  background: $color-tertiary;
  box-shadow:
          0 0 0 1px $color-quaternary,
          0 4px 10px rgba(0, 0, 0, 0.08);
  border-radius: 4px;
  color: $color-primary-darker;

  &.isDisabled {
    background: #ECECEC;
    color: transparentize(black, 0.44);
    border-color: #D0D0D0;
    opacity: 1;
  }

  .loadingProgress {
    background: transparentize($color-primary-darker, .8);
  }
}

.quinaryState {
  color: $color-primary;

  .loadingProgress {
    background: transparentize($color-primary-darker, .8);
  }

  &.withLoadingProgress {
    &:before {
      content: '';
      position: absolute;
      display: block;
      bottom: 0;
      left: 0;
      right: 0;
      height: 2px;
      background: $color-primary;
    }
  }
}

.fontLightState {
  font-weight: 300;
}
.fontRegularState {
  font-weight: 400;
}
.fontBoldState {
  font-weight: 600;
}

@keyframes spin {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}

.loader {
  content: '';
  z-index: 1;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translateY(-50%) translateX(-50%) rotate(100deg);
}

.loaderIcon {
  fill: currentColor;
  animation: spin 2s infinite cubic-bezier(0.34, 0.88, 0.72, 0.45);
  display: block;
  height: 100%;
  width: 100%;
}

.isLoading {
  .container {
    opacity: 0;
  }
  .loader {
    opacity: 1;
  }
}

.isRounded {
  border-radius: 1000px;
}

.loadingProgress {
  position: absolute;
  left: 0;
  top: 0;
  bottom: 0;
}